package dev.peerat.framework;

import java.lang.reflect.Method;
import java.util.regex.Matcher;

public class RouteBinder{
	
	//TODO interceptor -------> bind to a specific route, no all routes ? or both. Could be interesting for somes cases !
	
	private Class<?>[] types;
	private int[] bindMethod;
	private int parameterCount;
	
	public RouteBinder(){}
	
	public void bind(Class<?>... types){
		if(this.types == null){
			this.types = types;
			this.parameterCount = this.types.length;
			return;
		}
		Class<?>[] copy = new Class[this.types.length+types.length];
		System.arraycopy(this.types, 0, copy, 0, this.types.length);
		System.arraycopy(types, 0, copy, this.types.length, types.length);
		this.types = copy;
		this.parameterCount = this.types.length;
	}
	
	public void bindIndexes(Method method){
		Class<?>[] parameters = method.getParameterTypes();
		this.bindMethod = new int[4+(types == null ? 0 : types.length)];
		this.bindMethod[0] = findIndex(parameters, Matcher.class);
		this.bindMethod[1] = findIndex(parameters, Context.class);
		this.bindMethod[2] = findIndex(parameters, HttpReader.class);
		this.bindMethod[3] = findIndex(parameters, HttpWriter.class);
		if(this.types == null) return;
		for(int i = 0; i < this.types.length; i++){
			this.bindMethod[4+i] = findIndex(parameters, this.types[i]);
		}
		this.types = null;
	}
	
	public int getParameterCount(){
		return this.parameterCount;
	}
	
	public Object[] bindMethod(Method method, Matcher matcher, Context context, HttpReader reader, HttpWriter writer, Object[] objects){
		Object[] result = new Object[method.getParameterCount()];
		setElement(result, bindMethod[0], matcher);
		setElement(result, bindMethod[1], context);
		setElement(result, bindMethod[2], reader);
		setElement(result, bindMethod[3], writer);
		for(int i = 0; i < objects.length; i++){
			setElement(result, bindMethod[4+i], objects[i]);
		}
		return result;
	}
	
	private void setElement(Object[] array, int position, Object element){
		if(position < 0) return;
		array[position] = element; 
	}
	
	private int findIndex(Class<?>[] array, Class<?> type){
		for(int i = 0; i < array.length; i++){
			Class<?> clazz = array[i];
			if(type.isAssignableFrom(clazz)) return i;
		}
		return -1;
	}

}
